MorgDKP2 = LibStub("AceAddon-3.0"):NewAddon("MorgDKP2", "AceEvent-3.0", "AceConsole-3.0")

local L = LibStub("AceLocale-3.0"):GetLocale("MorgDKP2")
local C = LibStub("AceConfigDialog-3.0")
local CC = LibStub("AceConfigCmd-3.0")

local mdkp = MorgDKP2
mdkp.morgbid2version = tonumber(GetAddOnMetadata("MorgBid2", "X-Revision")) 

mdkp.version = "MorgDKP2 " .. GetAddOnMetadata("MorgDKP2", "Version") 
mdkp.webversion = 3.2

mdkp:SetDefaultModuleState(false)

mdkp.ZoneBosses = {}
mdkp.ZoneKills = {}
mdkp.Classcolors = {}
mdkp.ClasscolorsDEC = {[L["ALL"]] = {r = 1, g = 1, b = 1}}
mdkp.orderedclasses = {[1] = "DRUID", [2] = "HUNTER", [3] = "MAGE", [4] = "PALADIN", [5] = "PRIEST", [6] = "ROGUE", [7] = "SHAMAN", [8] = "WARLOCK", [9] = "WARRIOR", [10] = "DEATHKNIGHT", [11] = L["ALL"]}
mdkp.localizedclasses = {}
mdkp.reverseclass = {}
mdkp.Quality = {}

mdkp.Bits = { 	["DRUID"] 	= 	1024,
		["HUNTER"] 	= 	512,
		["MAGE"] 	=	256,
		["PALADIN"] 	= 	128,
		["PRIEST"] 	= 	64,
		["ROGUE"] 	= 	32,
		["SHAMAN"] 	= 	16,
		["WARLOCK"] 	= 	8,
		["WARRIOR"] 	= 	4,
		["DEATHKNIGHT"]	= 	2,
		[L["ALL"]] 	= 	2047
}

mdkp.guildstatustext = {[L["ONLINE"]] = {n = L["ONLINE"], r = 0, g = 1, b = 0},
			[L["OFFLINE"]] = {n = L["OFFLINE"], r = 1, g = 0, b = 0},
			[L["INRAID"]] = {n = L["INRAID"], r = 1, g = 1, b = 1},
			[L["xINRAIDx"]] = {n = L["xINRAIDx"], r = 1, g = 1, b = 0},
			[L["UNKNOWN"]] = {n = L["UNKNOWN"], r = 0.5, g = 0.5, b = 0.5},
			["<AFK>"] = {n = "<AFK>", r = 1, g = 1, b = 0},
			[L["WAIT"]] =  {n = L["WAIT"], r = 1, g = 1, b = 0},
			[L["xWAITx"]] =  {n = L["xWAITx"], r = 1, g = 0, b = 0}}

mdkp.bidwarconflicts = {"Random", "Relational", "Percent", "SKall", "TakeBid", "SKSotC"}

mdkp.difftable = {[1] = "(10)", [2] = "(25)", [3] = "(10H)", [4] = "(25H)"}	

mdkp.Exports = {[1] = "MorgDKP2", [2] = "CTRT", [3] = "Guildlaunch"}

mdkp.Inviteformat = {[1] = L["Balance"], [2] = L["Earned"], [3] = L["Attendance"]}

local fmt = string.format
local sub = string.sub
local tinsert = table.insert
local tsort   = table.sort
local tremove = table.remove
local tostring = tostring 
local lower = string.lower
local find = string.find
local len = string.len
local upper = string.upper
local band = bit.band
local bor = bit.bor
local bxor = bit.bxor
local Player = UnitName("player")
local MorgDKP2_Options
local db	

local defaults = { 
	profile = {
   		alwaysloot = nil,
   		attendneed = 0,
   		attemptmode = nil,
   		autozone = true,
   		bank = nil,
   		currDKP = nil,
   		custom = L["NEW"],
		DBversion = 1.3,
   		devmode = nil,
   		dewpoint = "RIGHT",
		disenchanter = Player,
		dkpevents = true,
   		dkplistener = nil,
   		dkpstatustext = nil,
   		editrank = nil,
   		eqdkp = nil,
   		exportformat = 1,
   		guildlink = nil,
   		hints = true,
   		ignore68 = nil,
   		ignoreunique = nil,
   		InRaid = nil,
   		instancedifficulty = 1,
   		mbidcustom = nil,
   		mbidnag = nil,
   		mbidoffspec = true,
   		mbidupdating = true,
   		mlooter = Player,
   		multiPool = nil,
   		NEED = L["NEED"],
   		newatt = 10,
   		newdkp = 0,
   		newdkpname = "New Member DKP",
   		OFFSPEC = L["OFFSPEC"],
   		offspecamount = 15,
   		offspecmode = nil,
   		offspecpercent = nil,
   		OneEvent = nil,
   		OneEventNote = nil,
   		PASS = L["PASS"],
   		quality = 4,
   		raid = nil,
   		raidend = L["PENDING"],
   		raidended = nil,
   		raidexport = L["PENDING"],
   		raidlink = true,
   		raidlist = {L["NONE"]},
   		raidmembers = {Player},
   		raidnum = 0,
   		raidstart = L["PENDING"],
   		ranks = {},
   		sarthextra = nil,
   		savelvl = 200,
   		showearned = 2,
   		startrun = true,
   		TAKE = L["TAKE"],
   		takeamount = 25,
   		takemode = nil,
   		takepercent = nil,
   		usemorg = true,
   		useranks = {},
		weighrand = nil,
		dkpmodules = {
   				menu = {},
		},
   		modules = {
   			CoreModule = true,
   			LDBPlugin = true,
   			Tracker = true,
   			PointsDB = true,
   			Lootframe = true,
   			Waitlist = true,
   			Eventnaming = true,
   			RaidTracker = true,
   		},
   		moduleON = {},
   		items = { },
    		info = {},
    		media = {
    			font = "Friz Quadrata TT",
    			fontsize = 10,
    			border = "Blizzard Tooltip",
	    		background = "Blizzard Out of Control",
	    		scale = 1.2,
			backdropC = { .58, .58, .58, 1},
			borderC = { .96, .93, .26, .75},
			fontC = { 0, 0, 1},
    		},
    		raidlog = {
				playerinfo = { },
				join = { },
				leave = { },
				bosskills = { },
				loot = { }
		},
		lootbuffer = {},
		ignore = {	[14344] = true,
				[18562] = true,
				[20725] = true,
				[22448] = true,
				[22449] = true,
				[22450] = true,
				[29434] = true,
				[30311] = true,
				[30312] = true,
				[30313] = true,
				[30314] = true,
				[30316] = true,
				[30317] = true,
				[30318] = true,
				[30319] = true,
				[30320] = true,
				[32230] = true,
				[34057] = true,
				[40752] = true,
				[40753] = true,
				[45624] = true,
				[47241] = true,
				[49426] = true,
				[52722] = true
		},
   	},
}

--addon initialization

function mdkp:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("MorgDKP2DB", defaults, "Default")
	if AddonLoader and SlashCmdList["MORGDKP2"] then
    		SlashCmdList["MORGDKP2"] = nil
    		SlashCmdList["MDKP2"] = nil
	end
	self:RegisterChatCommand("mdkp2", "LoadOptionsSlash")
	self:RegisterChatCommand("morgdkp2", "LoadOptionsSlash")
end

function mdkp:OnEnable()
	self:debug("MorgDKP2 Enabled")
	
	db = mdkp.db.profile
	mdkp.dkpmenu = {}
	mdkp.dkpmenuconvert = {}
	mdkp.querytooltips = {}
	mdkp.frames = {}
	
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "EnterWorld")
	self:RegisterEvent("CHAT_MSG_WHISPER", "WhisperHandler")
	
	--get DB plug to load independent of other modules states if it is enabled in opts
	if self.db.profile.modules.LDBPlugin then	
		local LDB = self:GetModule("LDBPlugin", true)
		if LDB then 
			LDB:Enable()
			self.db.profile.modules["LDBPlugin"] = true
		else 
			self.db.profile.modules["LDBPlugin"] = nil
		end
	end
	if self.db.profile.alwaysloot then	
		local loot = self:GetModule("Lootframe", true)
		if loot then 
			loot:Enable() 
		end
	end
	self.db.profile.moduleON["CoreModule"] = nil
	self:SetupDKPMenu()
	self:SetupClasses()
	self:GetClassColors()
	self:FillQualities()
	self:addFilter()
	self:EnterWorld()	--hack for addonloader see if it breaks anything
	if AddonLoader and InterfaceOptionsFrame:IsShown() and not MorgDKP2_Options then self:LoadOptions() end
end

function mdkp:OnDisable()
	self:debug("MorgDKP2 Disabled")
	self:DeActivateCore()
end

function mdkp:LoadOptions()
	if not MorgDKP2_Options then
		local _, _, _, enabled = GetAddOnInfo("MorgDKP2_Options")
		if enabled then
			local success, fail = LoadAddOn("MorgDKP2_Options")
			if not success then 
				self:debug("Options loading failed because "..fail) 
				return
			end
		else
			self:debug("Please enable MorgDKP2_Options")
			return 
		end
	end
	MorgDKP2_Options = LibStub("AceAddon-3.0"):GetAddon("MorgDKP2_Options")
end

function mdkp:LoadOptionsSlash()
	self:LoadOptions()
	if not C.OpenFrames["MorgDKP2"] then C:Open("MorgDKP2") end
end

function mdkp:OnProfileChanged()
	db = self.db.profile
	for k,v in self:IterateModules() do
		v:UpdateDB()
		self:debug("Updated " ..v.modName)
	end
	self:CloseFrames()
	MorgDKP2_Options:OnProfileChanged()
end

function mdkp:SetupClasses()
	local classes = {}
	FillLocalizedClassList(classes)
	for class, localizedclass in pairs(classes) do
		local upperclass = string.upper(class)
		mdkp.localizedclasses[class] = localizedclass
		mdkp.reverseclass[localizedclass] = class
	end
end

function mdkp:GetClassColors()
	for class, color in pairs(CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS) do
		mdkp:SetClassColors(class, color)
	end
	if CUSTOM_CLASS_COLORS then
		CUSTOM_CLASS_COLORS:RegisterCallback(function()
        		for class, color in pairs(CUSTOM_CLASS_COLORS) do
               			mdkp:SetClassColors(class, color)
          		end
          	end)
	end
end

function mdkp:SetClassColors(class, color)
	mdkp.ClasscolorsDEC[class] = {r = color.r, g = color.g, b = color.b}
	mdkp.Classcolors[class] = "|c00" .. fmt("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
end

function mdkp:FillQualities()
	for i = 0, 6 do
  		local r, g, b, hex = GetItemQualityColor(i)
  		table.insert(mdkp.Quality, {n = _G[("ITEM_QUALITY" .. i .. "_DESC")], r = r, g = g, b = b})
  	end
end

function mdkp:SetupDKPMenu()
	for k,v in self:IterateModules() do
		if v then
			local dkp = v:IsDKP()
			if dkp then 
				local name, ref = v:GetName()
				table.insert(mdkp.dkpmenu, name) 
				mdkp.dkpmenuconvert[name] = ref
			end
		end
	end
	table.insert(mdkp.dkpmenu, L["Boss Attempt Mode"])
	mdkp.dkpmenuconvert[L["Boss Attempt Mode"]] = "attemptmode"
end

function mdkp:EnableModules(on)
	--toggle users current modules
	for k,v in self:IterateModules() do
		if self.db.profile.modules[k] and v.modref ~= "LDBPlugin" then
			if on then 
				v:Enable()
				self:debug("Enabled " ..v.modName)
			else
				if v.modName ~= "Lootframe" or (v.modName == "Lootframe" and not mdkp.db.profile.alwaysloot) then
					v:Disable()
					self:debug("Disabled " ..v.modName)
				end
			end
		end
	end
end

function mdkp:debug(message)
	if self.db.profile.devmode then
		self:Print(message)
	end
end

function mdkp:out(message)
	if message then
		DEFAULT_CHAT_FRAME:AddMessage(message)
	end
end

function mdkp:EnterWorld()
	local tracker = mdkp:GetModule("Tracker", true)
	if self:IsTrackedZone() then
		if not db.InRaid and db.autozone and tracker then tracker:BeginRaid() end
	elseif not UnitIsGhost("player") and db.InRaid and db.autozone and not mdkp.querytooltips["listdkp"] and tracker then tracker:ShowEndRaidFrame() 
	end
end

function mdkp:IsTrackedZone()
	local ZoneName = GetInstanceInfo()
	local inInstance, instanceType = IsInInstance()
	mdkp:debug(ZoneName)
	if not inInstance or instanceType ~= "raid" then 
		self.db.profile.menuzone = L["World Boss"]
		wipe(mdkp.ZoneBosses)
		wipe(mdkp.ZoneKills)
		mdkp.ZoneBosses[1] = L["World Boss"]
		if not UnitIsGhost("player") then self:DeActivateCore() end
		return false 
	else
		self.db.profile.menuzone = ZoneName
		self:ActivateCore()
		return true
	end
end

function mdkp:ActivateCore(force)
	local CoreState = self:GetCoreState()
	local Tracker = mdkp:GetModule("Tracker", true)
	if force or (self.db.profile.autozone and not UnitIsGhost("player")) then
		if not CoreState then self:EnableModules(true) 
		else Tracker:ChangeZone() end
		self:ToggleLDBFuStatus(true)
	elseif CoreState then
		Tracker:ChangeZone()
	end
end

function mdkp:DeActivateCore(force)
	local CoreState = self:GetCoreState()
	if force or (self.db.profile.autozone and not UnitIsGhost("player") and not mdkp.querytooltips["listdkp"]) then 
		self:CloseFrames()
		if CoreState then self:EnableModules() end
		self:ToggleLDBFuStatus()
	end
end

function mdkp:CloseFrames()
	if mdkp.frames then
		if mdkp.frames["raidtracker"] and mdkp.frames["raidtracker"]:IsShown() then mdkp.frames["raidtracker"]:Hide() end
		if mdkp.frames["listdkp"] and mdkp.frames["listdkp"]:IsShown() then mdkp.frames["listdkp"]:Hide() end
		if mdkp.frames["version"] and mdkp.frames["version"]:IsShown() then mdkp.frames["version"]:Hide() end
	end
end

function mdkp:RestartMorgDKP2()
	mdkp:DeActivateCore(true)
	mdkp:ActivateCore(true)
end

function mdkp:ToggleLDBFuStatus(ON)
	local LDB = self:GetModule("LDBPlugin", true)
	if ON then
		if LDB then LDB:ActivateCore() end
	else
		if LDB then LDB:DeActivateCore() end
	end
end

function mdkp:ClearRaidDB()
	local db = mdkp.db.profile
	db.raidlog = {}
	db.raidlog.dkpevents = {}
	db.raidlog.aliases = {}
	db.lootbuffer = {}
	db.raidnum = 0
	db.raidstart = L["PENDING"]
	db.raidend = L["PENDING"]
	db.raidexport = L["PENDING"]
	db.InRaid = nil
	self:out(L["Cleared current raid database."])
end

function mdkp:GetCoreState()
	local Core = mdkp:GetModule("CoreModule", true)
	return Core:IsEnabled()
end

function mdkp:WhisperHandler(_, txt, sender)
	txt = string.utf8upper(txt)
	local command = string.sub(txt, 1, 4)
	if command ~= "MBID" and command ~= "DKPL" then return end
	
	--get current state
	local Core = mdkp:GetModule("CoreModule", true)
	local active = Core:IsEnabled()
	if not active then 
		self:EnableModules(true) 
		self:ToggleLDBFuStatus(true)
	end
	Core:IncomingWhispers(command, sender, txt)
	
	--turn off if was off
	if not active then 
		self:EnableModules() 
		self:ToggleLDBFuStatus() 
	end
end

function mdkp:addFilter()
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", 	function(_, event, msg, player)
									txt = string.utf8upper(msg)
									local command = string.sub(txt, 1, 4)
									if command ~= "MBID" and command ~= "DKPL" then return nil end
									return true
								end
	)
end

